package test;

import java.util.Map;
import com.borland.jbuilder.build.JspCompiler;
import com.borland.jbuilder.paths.GenericInstallModel;
import com.borland.jbuilder.paths.PathSet;
import com.borland.jbuilder.paths.PathSetManager;
import com.borland.jbuilder.server.JspServletService;
import com.borland.jbuilder.server.JspServletService$Feature;
import com.borland.jbuilder.server.ProjectServerModel;
import com.borland.jbuilder.server.Server;
import com.borland.jbuilder.server.ui.JspServletServiceRunConfigurationPage;
import com.borland.jbuilder.web.DeploymentDescriptorSupport;
import com.borland.jbuilder.web.xml.WebXmlSupport;
import com.borland.primetime.properties.PropertyPage;
import com.borland.primetime.util.Version;
import com.borland.primetime.vfs.Url;


/**
 * <p>Titre : </p>
 * <p>Description : </p>
 * <p>Copyright : Copyright (c) 2003</p>
 * <p>Socit : </p>
 * @author non attribuable
 * @version 1.0
 */
public class JonasJspServletService extends JspServletService
{
   private static Feature serviceJspFeature[];
   private static DeploymentDescriptorSupport descriptor[];
   private Server m_Server = null;

   private static final String jspPath[] = {"lib/web_catalina.jar"};
   private static final String servletPath[] = {"lib/web_catalina.jar"};

   protected GenericInstallModel jspcInstallModel;
   protected GenericInstallModel servletInstallModel;

   static
   {
      descriptor = (new DeploymentDescriptorSupport[] {
                    new WebXmlSupport(JspServletService.Feature.SERVLET_2_3),
                    new JonasXmlSupport()});
      serviceJspFeature = (new Feature[] {
                           com.borland.jbuilder.server.JspServletService.Feature.JSP_1_2,
                           com.borland.jbuilder.server.JspServletService.Feature.SERVLET_2_3});
   }

   protected com.borland.jbuilder.server.Feature[] getFeatures()
   {
      return serviceJspFeature;
   }

   /**
    * Constructor
    * @param p_Server
    */
   public JonasJspServletService(JonasServer p_Server)
   {
      super(p_Server);
      servletInstallModel = new GenericInstallModel();
      servletInstallModel.setClassEntries(servletPath);
      jspcInstallModel = new GenericInstallModel();
      jspcInstallModel.setClassEntries(jspPath);
   }

   /**
    * Returns a Version description of the Servlet API that this container
    * supports
    * @return Version
    */
   public Version getServletVersion()
   {
      return com.borland.jbuilder.server.JspServletService.Feature.SERVLET_2_3.getVersion();
   }

   /**
    * Returns the configuration page for jsp servlet
    * @param projectservermodel
    * @param map
    * @return propertypage
    */
   public PropertyPage getRunConfigPropertyPage(ProjectServerModel projectservermodel, Map map)
   {
      return new JspServletServiceRunConfigurationPage(projectservermodel, map, this);
   }

   /**
    * Returns the name of the Servlet API
    * @return
    */
   protected String getServletApiPathSetName()
   {
      return String.valueOf(String.valueOf(getServer().getShortNameWithVersion())).concat(" Servlet");
   }

   /**
    * Create the Servlet API for JOnAS Tomcat
    * @param pathset
    */
   protected void buildServletApiPathSet(PathSet pathset)
   {
      servletInstallModel.attemptPathSet(pathset, getServer().getHomeDirectory());
      pathset.save();
   }

   /**
    * Returns PathSet for Servlet/JSP API library used by server. It is the
    * responsibility of the setup to create this pathset, usually in the
    * User home. This way, the project-specific Servlet library can point to it
    * for its Servlet API classes. If possible, do not include internal
    * implementation classes. If the server is not properly configured,
    * this should be an empty pathset.
    *
    * @return PathSet
    */
   public PathSet getServletApiPathSet()
   {
      PathSet pathset = PathSetManager.getLibrary(getServletApiPathSetName());
      if(getServer().isSetup())
      {
         buildServletApiPathSet(pathset);
      }
      return pathset;
   }

   /**
    * Returns a Version description of the JSP API that this container
    * supports; e.g. 1.2
    *
    * @return Version cannot be null
    */
   public Version getJspVersion()
   {
      return com.borland.jbuilder.server.JspServletService.Feature.JSP_1_2.getVersion();
   }

   /**
    * This path is used for JSP CodeInsight, and therefore must contain the
    * class named by getJspImplementationClass. If the server's classes contain
    * the JSP classes, then this can delegate to getClassPath.
    *
    * @return classpath array of Urls for each classpath entry. If no classpath
    * is set, return an empty string.
    */
   public Url[] getJspClassPath()
   {
      return jspcInstallModel.createPath(jspcInstallModel.getClassEntries(), getServer().getHomeDirectory());
   }

   /**
    * Most web servers have a Java-based command-line compiler that can be used
    * to pre-compile JSPs at build time to check for errors.
    *
    * @return compiler interface implementation, or null if the web server does
    * not have one
    */
   public JspCompiler getJspCompiler()
   {
      return new com.borland.jbuilder.web.tomcat.JasperJspCompiler(this);
   }

   /**
    * CodeInsight for JSPs needs the name of the base JSP implementation class
    * e.g. "com.sun.jsp.runtime.HttpJspBase" for JSWDK
    * @return String The fully-qualified class name
    */
   public String getJspImplementationClass()
   {
      return JonasRessource.get("JSP_CLASS");
   }

   /**
    * Returns the support info for the deployment descriptors used by the web
    * server. At a minimum, a Servlet-API-compliant web server must support the
    * standard web.xml file. A standard implementation (WebXmlSupport) is
    * provided, but the server may use its own customized support.
    * The web server may also use its own proprietary deployment descriptor,
    * like JOnAS's jonas-web.xml. The standard support object should be first
    * in the array.
    *
    * @return DeploymentDescriptorSupport[]
    */
   public DeploymentDescriptorSupport[] getDeploymentDescriptors()
   {
      return descriptor;
   }
}
