package test;

import java.awt.BorderLayout;
import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JPanel;
import com.borland.jbuilder.JBuilderHelp;
import com.borland.jbuilder.server.BasicConfigurationPageAccess;
import com.borland.jbuilder.server.CustomConfigurationPage;
import com.borland.primetime.help.HelpTopic;

/**
 * <p>Titre : </p>
 * <p>Description : </p>
 * <p>Copyright : Copyright (c) 2003</p>
 * <p>Socit : </p>
 * @author non attribuable
 * @version 1.0
 */
public class JonasServerConfigurationPage extends CustomConfigurationPage implements JonasProperties
{
   private JCheckBox m_JonasVersion;
   private boolean m_isJonas31 = false;

   /**
    * Constructor
    * @param p_BasicConfigurationPageAccess
    */
   public JonasServerConfigurationPage(BasicConfigurationPageAccess p_BasicConfigurationPageAccess)
   {
      super(p_BasicConfigurationPageAccess);
      createCustomPage();
   }

   /**
    * This function create the graphic components visible in the personalisation
    * page
    */
   private void createCustomPage()
   {
      this.setLayout(new BorderLayout());

      JPanel root = new JPanel(new BorderLayout());
      root.setBorder(BorderFactory.createTitledBorder("JOnAS Version"));

      // CheckBox pour la version de Jonas
      m_JonasVersion = new JCheckBox("JOnAS 3.1 version or greater");
      root.add(m_JonasVersion, BorderLayout.WEST);
      this.add(root, BorderLayout.NORTH);
   }

   /**
    * This function sets the default values
    */
   public void setToDefaults()
   {
      // Nothing to do
   }

   /**
    * Method that checks if the page is valid
    * @return boolean valid true if the page is valid
    */
   public boolean isPageValid()
   {
      // this page is always valid, it is just some options configuration
      return true;
   }

   /**
    * Method that returns true if the page is modified
    * @return boolean true if page modified
    */
   public boolean isModified()
   {
      boolean modified = true;
      if(m_isJonas31 != m_JonasVersion.isSelected())
      {
         modified = false;
      }
      return modified;
   }

   /**
    * this function returns the HelpTopic associated with server configuration
    * @return HelpTopic
    */
   public HelpTopic getHelpTopic()
   {
      return JBuilderHelp.TOPIC_DConfigureServers;
   }

   /**
    * This function reads the properties already loaded
    */
   public void readProperties()
   {
      if(JonasProperties.JONAS31_VERSION.getValue() != null &&
         JonasProperties.JONAS31_VERSION.getValue().equalsIgnoreCase("true"))
      {
         m_JonasVersion.setSelected(true);
         m_isJonas31 = true;
      }
      else
      {
         m_JonasVersion.setSelected(false);
         m_isJonas31 = false;
      }
   }

   /**
    * This function is called when the properties have to be saved
    */
   public void writeProperties()
   {
      if(m_JonasVersion.isSelected() == true)
      {
         JonasProperties.JONAS31_VERSION.setValue("true");
         m_isJonas31 = true;
      }
      else
      {
         JonasProperties.JONAS31_VERSION.setValue("false");
         m_isJonas31 = false;
      }
   }

}